package cn.citycraft.AuthMe.security;

import org.apache.commons.lang.ObjectUtils.Null;

import cn.citycraft.AuthMe.security.crypts.BCRYPT;
import cn.citycraft.AuthMe.security.crypts.BCRYPT2Y;
import cn.citycraft.AuthMe.security.crypts.CRAZYCRYPT1;
import cn.citycraft.AuthMe.security.crypts.CryptPBKDF2;
import cn.citycraft.AuthMe.security.crypts.CryptPBKDF2Django;
import cn.citycraft.AuthMe.security.crypts.DOUBLEMD5;
import cn.citycraft.AuthMe.security.crypts.IPB3;
import cn.citycraft.AuthMe.security.crypts.JOOMLA;
import cn.citycraft.AuthMe.security.crypts.MD5;
import cn.citycraft.AuthMe.security.crypts.MD5VB;
import cn.citycraft.AuthMe.security.crypts.MYBB;
import cn.citycraft.AuthMe.security.crypts.PHPBB;
import cn.citycraft.AuthMe.security.crypts.PHPFUSION;
import cn.citycraft.AuthMe.security.crypts.PLAINTEXT;
import cn.citycraft.AuthMe.security.crypts.ROYALAUTH;
import cn.citycraft.AuthMe.security.crypts.SALTED2MD5;
import cn.citycraft.AuthMe.security.crypts.SALTEDSHA512;
import cn.citycraft.AuthMe.security.crypts.SHA1;
import cn.citycraft.AuthMe.security.crypts.SHA256;
import cn.citycraft.AuthMe.security.crypts.SHA512;
import cn.citycraft.AuthMe.security.crypts.SMF;
import cn.citycraft.AuthMe.security.crypts.WBB3;
import cn.citycraft.AuthMe.security.crypts.WBB4;
import cn.citycraft.AuthMe.security.crypts.WHIRLPOOL;
import cn.citycraft.AuthMe.security.crypts.WORDPRESS;
import cn.citycraft.AuthMe.security.crypts.XAUTH;
import cn.citycraft.AuthMe.security.crypts.XF;

public enum HashAlgorithm {

	BCRYPT(BCRYPT.class),
	BCRYPT2Y(BCRYPT2Y.class),
	CRAZYCRYPT1(CRAZYCRYPT1.class),
	CUSTOM(Null.class),
	DOUBLEMD5(DOUBLEMD5.class),
	IPB3(IPB3.class),
	JOOMLA(JOOMLA.class),
	MD5(MD5.class),
	MD5VB(MD5VB.class),
	MYBB(MYBB.class),
	PBKDF2(CryptPBKDF2.class),
	PBKDF2DJANGO(CryptPBKDF2Django.class),
	PHPBB(PHPBB.class),
	PHPFUSION(PHPFUSION.class),
	PLAINTEXT(PLAINTEXT.class),
	ROYALAUTH(ROYALAUTH.class),
	SALTED2MD5(SALTED2MD5.class),
	SALTEDSHA512(SALTEDSHA512.class),
	SHA1(SHA1.class),
	SHA256(SHA256.class),
	SHA512(SHA512.class),
	SMF(SMF.class),
	WBB3(WBB3.class),
	WBB4(WBB4.class),
	WHIRLPOOL(WHIRLPOOL.class),
	WORDPRESS(WORDPRESS.class),
	XAUTH(XAUTH.class),
	XENFORO(XF.class);

	Class<?> classe;

	HashAlgorithm(final Class<?> classe) {
		this.classe = classe;
	}

	public Class<?> getclasse() {
		return classe;
	}

}
